﻿using CustomEditButton.Models;
using Kendo.Mvc.Extensions;
using Kendo.Mvc.UI;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace CustomEditButton.Controllers
{
    public class SchedulerController : Controller
    {
        private IList<AppointmentSummaryModel> GetAll()
        {
            IList<AppointmentSummaryModel> tasks = HttpContext.Session["tasks"] as IList<AppointmentSummaryModel>;

            if (tasks == null)
            {
                tasks = new List<AppointmentSummaryModel>()
                {
                    new AppointmentSummaryModel() { Id = 1, Start = DateTime.Now, End = DateTime.Now.AddHours(3), Title = "Test Appointment 1", RecurrenceRule = "FREQ=DAILY;COUNT=5" },
                    new AppointmentSummaryModel() { Id = 3, Start = DateTime.Now.AddDays(1), End = DateTime.Now.AddDays(1).AddHours(3), Title = "Test Appointment 3" },
                    new AppointmentSummaryModel() { Id = 2, Start = DateTime.Now.AddDays(-3), End = DateTime.Now.AddDays(-3).AddHours(3), Title = "Test Appointment 2" }
                };

                HttpContext.Session["tasks"] = tasks;
            }

            return tasks;
        }

        public ActionResult Read([DataSourceRequest] DataSourceRequest request)
        {
            return Json(GetAll().ToDataSourceResult(request));
        }

        public virtual JsonResult Create_Event([DataSourceRequest] DataSourceRequest request, AppointmentSummaryModel schedule)
        {
            if (ModelState.IsValid)
            {
                var tasks = GetAll();
                schedule.Id = tasks.Count + 1;
                tasks.Add(schedule);
                HttpContext.Session["tasks"] = tasks;
            }

            return Json(new[] { schedule }.ToDataSourceResult(request, ModelState));
        }
        public virtual JsonResult Update_Event([DataSourceRequest] DataSourceRequest request, AppointmentSummaryModel schedule)
        {
            if (ModelState.IsValid)
            {
                var tasks = GetAll();
                tasks = tasks.Where(t => t.Id != schedule.Id).ToList();
                tasks.Add(schedule);
                HttpContext.Session["tasks"] = tasks;
            }

            return Json(new[] { schedule }.ToDataSourceResult(request, ModelState));
        }
        public virtual JsonResult Destroy_Event([DataSourceRequest] DataSourceRequest request, AppointmentSummaryModel schedule)
        {
            if (ModelState.IsValid)
            {
                var tasks = GetAll();
                tasks = tasks.Where(t => t.Id != schedule.Id).ToList();
                HttpContext.Session["tasks"] = tasks;
            }

            return Json(new[] { schedule }.ToDataSourceResult(request, ModelState));
        }
    }
}